local Zifnabs_Config_Buffmon = {}
_G.Zifnabs_Config_Buffmon = Zifnabs_Config_Buffmon

local config_frame=getglobal("Zifnabs_Configuration")
local my_name="Zifnabs_Configuration_Buffmon"
local my_frame=getglobal(my_name)
local unsaved_changes=false

getglobal(my_name.."_FPS_Active_Text"):SetText(Zifnabs.LANG.Config_BUFFMON_FPS_ACTIVE)
getglobal(my_name.."_HP_Active_Text"):SetText(Zifnabs.LANG.Config_BUFFMON_HP_ACTIVE)
getglobal(my_name.."_HP_HUD_Text"):SetText(Zifnabs.LANG.Config_HUD)
getglobal(my_name.."_HP_Sound_Text"):SetText(Zifnabs.LANG.Config_SOUND)
getglobal(my_name.."_Buffs_Active_Text"):SetText(Zifnabs.LANG.Config_BUFFMON_BUFF_ACTIVE)
getglobal(my_name.."_Buffs_HUD_Text"):SetText(Zifnabs.LANG.Config_HUD)
getglobal(my_name.."_Buffs_Sound_Text"):SetText(Zifnabs.LANG.Config_SOUND)

Zifnabs_Config:register_module(Zifnabs.LANG.Config_BUFFMON_SELECT,Zifnabs_Config_Buffmon)

-- ******************************************************************************************
-- * ON EVENT
-- ******************************************************************************************
function Zifnabs_Config_Buffmon:check(widget)
	local id,name,part=Zifnabs:parse_name(widget)
	local value=widget:IsChecked()
	if id=="fps_active" then Zifnabs_Settings.fpsmon.active=value
	elseif id=="hp_active" then Zifnabs_Settings.hpmon.active=value
	elseif id=="hp_sound" and value==true then Zifnabs_Settings.hpmon.sound="aaaah.mp3"
	elseif id=="hp_sound"  then Zifnabs_Settings.hpmon.sound=""
	elseif id=="hp_hud" then Zifnabs_Settings.hpmon.hud=value
	elseif id=="buffs_active" then Zifnabs_Settings.buffmon.active=value
	elseif id=="buffs_sound" and value==true then Zifnabs_Settings.buffmon.sound="dingdong.mp3"
	elseif id=="buffs_sound" then Zifnabs_Settings.buffmon.sound=""
	elseif id=="buffs_hud" then Zifnabs_Settings.buffmon.hud=value
	end
	Zifnabs_Buffmon:reload_settings()
	Zifnabs_Config_Buffmon:enter()
end

function Zifnabs_Config_Buffmon:button(widget)
	local id,name,part=Zifnabs:parse_name(widget)
	if id=="buffs_minus" then Zifnabs_Settings.buffmon.time=math.max(1,Zifnabs_Settings.buffmon.time-1)
	elseif id=="buffs_plus" then Zifnabs_Settings.buffmon.time=math.min(999,Zifnabs_Settings.buffmon.time+1)
	elseif id=="hp_minus" then Zifnabs_Settings.hpmon.percent=math.max(1,Zifnabs_Settings.hpmon.percent-1)
	elseif id=="hp_plus" then Zifnabs_Settings.hpmon.percent=math.min(99,Zifnabs_Settings.hpmon.percent+1)
	elseif id=="red_minus" then Zifnabs_Settings.fpsmon.red=math.max(1,Zifnabs_Settings.fpsmon.red-1)
	elseif id=="red_plus" then 
		Zifnabs_Settings.fpsmon.red=math.min(97,Zifnabs_Settings.fpsmon.red+1)
		Zifnabs_Settings.fpsmon.yellow=math.max(Zifnabs_Settings.fpsmon.red+1,Zifnabs_Settings.fpsmon.yellow)
		Zifnabs_Settings.fpsmon.green=math.max(Zifnabs_Settings.fpsmon.yellow+1,Zifnabs_Settings.fpsmon.green)
	elseif id=="yellow_minus" then 
		Zifnabs_Settings.fpsmon.yellow=math.max(2,Zifnabs_Settings.fpsmon.yellow-1)
		Zifnabs_Settings.fpsmon.red=math.min(Zifnabs_Settings.fpsmon.red,Zifnabs_Settings.fpsmon.yellow-1)
	elseif id=="yellow_plus" then 
		Zifnabs_Settings.fpsmon.yellow=math.min(98,Zifnabs_Settings.fpsmon.yellow+1)
		Zifnabs_Settings.fpsmon.green=math.max(Zifnabs_Settings.fpsmon.yellow+1,Zifnabs_Settings.fpsmon.green)
	elseif id=="green_minus" then 
		Zifnabs_Settings.fpsmon.green=math.max(3,Zifnabs_Settings.fpsmon.green-1)
		Zifnabs_Settings.fpsmon.yellow=math.min(Zifnabs_Settings.fpsmon.yellow,Zifnabs_Settings.fpsmon.green-1)
		Zifnabs_Settings.fpsmon.red=math.min(Zifnabs_Settings.fpsmon.red,Zifnabs_Settings.fpsmon.yellow-1)
	elseif id=="green_plus" then Zifnabs_Settings.fpsmon.green=math.min(99,Zifnabs_Settings.fpsmon.green+1)
	end
	Zifnabs_Buffmon:reload_settings()
	Zifnabs_Config_Buffmon:enter()
end

-- ******************************************************************************************
-- * API Funktionen für Zifnabs_Config
-- ******************************************************************************************
function Zifnabs_Config_Buffmon:enter()
	my_frame:Show()
	getglobal(my_name.."_FPS_Active"):SetChecked(Zifnabs_Settings.fpsmon.active)
	getglobal(my_name.."_FPS_red_Value_Text"):SetText(Zifnabs_Settings.fpsmon.red)
	getglobal(my_name.."_FPS_yellow_Value_Text"):SetText(Zifnabs_Settings.fpsmon.yellow)
	getglobal(my_name.."_FPS_green_Value_Text"):SetText(Zifnabs_Settings.fpsmon.green)
	getglobal(my_name.."_FPS_red_Value_Text"):SetColor(1,0,0)
	getglobal(my_name.."_FPS_yellow_Value_Text"):SetColor(1,1,0)
	getglobal(my_name.."_FPS_green_Value_Text"):SetColor(0,1,0)
	getglobal(my_name.."_HP_Active"):SetChecked(Zifnabs_Settings.hpmon.active)
	getglobal(my_name.."_HP_HUD"):SetChecked(Zifnabs_Settings.hpmon.hud)
	getglobal(my_name.."_HP_Sound"):SetChecked((Zifnabs_Settings.hpmon.sound~=""))
	getglobal(my_name.."_HP_Value_Text"):SetText(Zifnabs_Settings.hpmon.percent.."%")
	getglobal(my_name.."_Buffs_Active"):SetChecked(Zifnabs_Settings.buffmon.active)
	getglobal(my_name.."_Buffs_HUD"):SetChecked(Zifnabs_Settings.buffmon.hud)
	getglobal(my_name.."_Buffs_Sound"):SetChecked((Zifnabs_Settings.buffmon.sound~=""))
	getglobal(my_name.."_Buffs_Value_Text"):SetText(Zifnabs_Settings.buffmon.time.."s")
end

function Zifnabs_Config_Buffmon:leave()
	if unsaved_changes then Zifnabs_Config:save_ignore_abort("ASK")  
	else 
		my_frame:Hide()
		Zifnabs_Config:left_menu()
	end
end
function Zifnabs_Config_Buffmon:save() unsaved_changes=false end -- unsaved_changes gibt es bei Buffmon gar nicht
function Zifnabs_Config_Buffmon:ignore()	unsaved_changes=false end
function Zifnabs_Config_Buffmon:disable() my_frame:Disable() end
function Zifnabs_Config_Buffmon:enable()	my_frame:Enable() end
